//---------------------------------------------------------------------------------------
// Gandalf Graphix Cool Static aka Label - HotTracking effect, Transparency, Pushable Eff
// (C)2001 Alexander Turkovsky
//---------------------------------------------------------------------------------------
// Usage:
//   in dialog header file change needed CStatic refer to GGLabel
//   if you want to use hot tracking or pushable effect you need set notify
//   option in object(Static) properties (Dialog Editor)
//

#ifndef GGLABEL_H_
#define GGLABEL_H_


#define GGLABEL_STATE_NORMAL   0
#define GGLABEL_STATE_HILITE   1
#define GGLABEL_STATE_PRESSED  2
#define GGLABEL_CHECKTIMER_ID  0x9724

//---------------------------------------------------------------------------------------
class GGLabel : public CStatic
{
   DECLARE_DYNAMIC( GGLabel );
protected:
   COLORREF m_NormalColor;
   COLORREF m_HiliteColor;
   COLORREF m_PressedColor;
   int      m_LabelState;
   bool     m_Captured;
   bool     m_HotTracking;
   bool     m_IsPushable;
   bool     m_SimulatePress;

   // Generated message map functions
   //{{AFX_MSG(GGLabel)
      afx_msg void OnPaint();
      afx_msg void OnEnable( BOOL bEnable );
   //}}AFX_MSG

   //{{AFX_VIRTUAL(GGLabel)
      virtual LRESULT DefWindowProc( UINT Msg, WPARAM wParam, LPARAM lParam );
	//}}AFX_VIRTUAL
public:
   GGLabel( void );// Construction
   virtual ~GGLabel() {};
   
   void SetNormalColor( COLORREF Clr );
   void SetHiliteColor( COLORREF Clr );
   void SetPressedColor( COLORREF Clr );
   COLORREF GetNormalColor( void );
   COLORREF GetHiliteColor( void );
   COLORREF GetPressedColor( void );
   void SetHotTracking( bool HotTracking );
   void SetPushability( bool Pushability );
   bool GetHotTracking( void );
   bool GetPushability( void );

   void SetEffectOptions( bool HotTracking = true, bool Pushability = true );
   void SetColors( COLORREF NormalClr = RGB( 0, 0, 0 ), COLORREF HiliteClr = RGB( 0, 0, 120 ), COLORREF PushClr = RGB( 120, 0, 0 ) );

   DECLARE_MESSAGE_MAP()
};


#endif